%.........PARAMETERS.........
Number_of_subcarriers = 256; 
cp_len = Number_of_subcarriers*0.25;
modulation = 4;
symbol_size = 256;
bitspersymbol = log2(modulation);

Data = InputPort1.Sequence';
reshape_data = reshape(Data,bitspersymbol,length(Data)/2);
decidata = bi2de(reshape_data');

%.........MAPPING........
hModulator = comm.QPSKModulator('BitInput', false,'PhaseOffset', pi/4);
hmod = step(hModulator,decidata);

%....SERIAL TO PARALLEL......
S2P = reshape(hmod.',Number_of_subcarriers,symbol_size);

cp_start = Number_of_subcarriers - cp_len;


for i=1:symbol_size    
ifft_Subcarrier(:,i) = ifft((S2P(:,i)),Number_of_subcarriers);%IFFT of 256
for j = 1:cp_len
cyclic_prefix(j,i) = ifft_Subcarrier(cp_start+j,i);%cyclic prefix of 64
end
Append_prefix(:,i) = vertcat( cyclic_prefix(:,i), ifft_Subcarrier(:,i));%Append Prefix of 256+64
%Appends prefix to each subcarriers
end

%convert to serial stream for transmission of signal
[rows_Append_prefix, cols_Append_prefix]=size(Append_prefix);
len_ofdm_data = rows_Append_prefix*cols_Append_prefix;

%Signal transmitted OFDM
ofdm_signal = reshape(Append_prefix, 1, len_ofdm_data);
OutputPort1.TypeSignal = 'Electrical';
% OutputPort2.TypeSignal = 'Electrical';
OutputPort1.Sampled = ofdm_signal;
% OutputPort2.Sampled = ofdm_signal;

